# coding: utf-8

"""
    The Blue Alliance API v3

    # Overview    Information and statistics about FIRST Robotics Competition teams and events.   # Authentication   All endpoints require an Auth Key to be passed in the header `X-TBA-Auth-Key`. If you do not have an auth key yet, you can obtain one from your [Account Page](/account).    A `User-Agent` header may need to be set to prevent a 403 Unauthorized error.  # noqa: E501

    The version of the OpenAPI document: 3.8.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from tbaapiv3client.configuration import Configuration


class EventOPRs(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'oprs': 'dict(str, float)',
        'dprs': 'dict(str, float)',
        'ccwms': 'dict(str, float)'
    }

    attribute_map = {
        'oprs': 'oprs',
        'dprs': 'dprs',
        'ccwms': 'ccwms'
    }

    def __init__(self, oprs=None, dprs=None, ccwms=None, local_vars_configuration=None):  # noqa: E501
        """EventOPRs - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._oprs = None
        self._dprs = None
        self._ccwms = None
        self.discriminator = None

        if oprs is not None:
            self.oprs = oprs
        if dprs is not None:
            self.dprs = dprs
        if ccwms is not None:
            self.ccwms = ccwms

    @property
    def oprs(self):
        """Gets the oprs of this EventOPRs.  # noqa: E501

        A key-value pair with team key (eg `frc254`) as key and OPR as value.  # noqa: E501

        :return: The oprs of this EventOPRs.  # noqa: E501
        :rtype: dict(str, float)
        """
        return self._oprs

    @oprs.setter
    def oprs(self, oprs):
        """Sets the oprs of this EventOPRs.

        A key-value pair with team key (eg `frc254`) as key and OPR as value.  # noqa: E501

        :param oprs: The oprs of this EventOPRs.  # noqa: E501
        :type: dict(str, float)
        """

        self._oprs = oprs

    @property
    def dprs(self):
        """Gets the dprs of this EventOPRs.  # noqa: E501

        A key-value pair with team key (eg `frc254`) as key and DPR as value.  # noqa: E501

        :return: The dprs of this EventOPRs.  # noqa: E501
        :rtype: dict(str, float)
        """
        return self._dprs

    @dprs.setter
    def dprs(self, dprs):
        """Sets the dprs of this EventOPRs.

        A key-value pair with team key (eg `frc254`) as key and DPR as value.  # noqa: E501

        :param dprs: The dprs of this EventOPRs.  # noqa: E501
        :type: dict(str, float)
        """

        self._dprs = dprs

    @property
    def ccwms(self):
        """Gets the ccwms of this EventOPRs.  # noqa: E501

        A key-value pair with team key (eg `frc254`) as key and CCWM as value.  # noqa: E501

        :return: The ccwms of this EventOPRs.  # noqa: E501
        :rtype: dict(str, float)
        """
        return self._ccwms

    @ccwms.setter
    def ccwms(self, ccwms):
        """Sets the ccwms of this EventOPRs.

        A key-value pair with team key (eg `frc254`) as key and CCWM as value.  # noqa: E501

        :param ccwms: The ccwms of this EventOPRs.  # noqa: E501
        :type: dict(str, float)
        """

        self._ccwms = ccwms

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EventOPRs):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, EventOPRs):
            return True

        return self.to_dict() != other.to_dict()
