# coding: utf-8

"""
    The Blue Alliance API v3

    # Overview    Information and statistics about FIRST Robotics Competition teams and events.   # Authentication   All endpoints require an Auth Key to be passed in the header `X-TBA-Auth-Key`. If you do not have an auth key yet, you can obtain one from your [Account Page](/account).    A `User-Agent` header may need to be set to prevent a 403 Unauthorized error.  # noqa: E501

    The version of the OpenAPI document: 3.8.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from tbaapiv3client.configuration import Configuration


class ZebraTeam(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'team_key': 'str',
        'xs': 'list[float]',
        'ys': 'list[float]'
    }

    attribute_map = {
        'team_key': 'team_key',
        'xs': 'xs',
        'ys': 'ys'
    }

    def __init__(self, team_key=None, xs=None, ys=None, local_vars_configuration=None):  # noqa: E501
        """ZebraTeam - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._team_key = None
        self._xs = None
        self._ys = None
        self.discriminator = None

        self.team_key = team_key
        self.xs = xs
        self.ys = ys

    @property
    def team_key(self):
        """Gets the team_key of this ZebraTeam.  # noqa: E501

        The TBA team key for the Zebra MotionWorks data.  # noqa: E501

        :return: The team_key of this ZebraTeam.  # noqa: E501
        :rtype: str
        """
        return self._team_key

    @team_key.setter
    def team_key(self, team_key):
        """Sets the team_key of this ZebraTeam.

        The TBA team key for the Zebra MotionWorks data.  # noqa: E501

        :param team_key: The team_key of this ZebraTeam.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and team_key is None:  # noqa: E501
            raise ValueError("Invalid value for `team_key`, must not be `None`")  # noqa: E501

        self._team_key = team_key

    @property
    def xs(self):
        """Gets the xs of this ZebraTeam.  # noqa: E501

        A list containing doubles and nulls representing a teams X position in feet at the corresponding timestamp. A null value represents no tracking data for a given timestamp.  # noqa: E501

        :return: The xs of this ZebraTeam.  # noqa: E501
        :rtype: list[float]
        """
        return self._xs

    @xs.setter
    def xs(self, xs):
        """Sets the xs of this ZebraTeam.

        A list containing doubles and nulls representing a teams X position in feet at the corresponding timestamp. A null value represents no tracking data for a given timestamp.  # noqa: E501

        :param xs: The xs of this ZebraTeam.  # noqa: E501
        :type: list[float]
        """
        if self.local_vars_configuration.client_side_validation and xs is None:  # noqa: E501
            raise ValueError("Invalid value for `xs`, must not be `None`")  # noqa: E501

        self._xs = xs

    @property
    def ys(self):
        """Gets the ys of this ZebraTeam.  # noqa: E501

        A list containing doubles and nulls representing a teams Y position in feet at the corresponding timestamp. A null value represents no tracking data for a given timestamp.  # noqa: E501

        :return: The ys of this ZebraTeam.  # noqa: E501
        :rtype: list[float]
        """
        return self._ys

    @ys.setter
    def ys(self, ys):
        """Sets the ys of this ZebraTeam.

        A list containing doubles and nulls representing a teams Y position in feet at the corresponding timestamp. A null value represents no tracking data for a given timestamp.  # noqa: E501

        :param ys: The ys of this ZebraTeam.  # noqa: E501
        :type: list[float]
        """
        if self.local_vars_configuration.client_side_validation and ys is None:  # noqa: E501
            raise ValueError("Invalid value for `ys`, must not be `None`")  # noqa: E501

        self._ys = ys

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ZebraTeam):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ZebraTeam):
            return True

        return self.to_dict() != other.to_dict()
